package com.cyksj.common.util;

import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpResponse;
import cn.hutool.http.Method;
import cn.hutool.json.JSONObject;
import com.cyksj.common.exception.BusinessRuntimeException;
import com.tencentcloudapi.captcha.v20190722.CaptchaClient;
import com.tencentcloudapi.captcha.v20190722.models.DescribeCaptchaResultRequest;
import com.tencentcloudapi.captcha.v20190722.models.DescribeCaptchaResultResponse;
import com.tencentcloudapi.common.Credential;
import com.tencentcloudapi.common.exception.TencentCloudSDKException;
import com.tencentcloudapi.common.profile.ClientProfile;
import com.tencentcloudapi.common.profile.HttpProfile;
import com.tencentcloudapi.sms.v20210111.SmsClient;
import com.tencentcloudapi.sms.v20210111.models.SendSmsRequest;
import com.tencentcloudapi.sms.v20210111.models.SendSmsResponse;
import com.tencentcloudapi.sms.v20210111.models.SendStatus;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.List;
import java.util.stream.Collectors;

/**
 * @author chan
 * @date 2022/10/13 11:29 AM
 */
public class SmsUtil {

    private static final String URL = "http://sms-api.luosimao.com/v1/send.json";

    private static final String BATCH_URL = "http://sms-api.luosimao.com/v1/send_batch.json";

    private static final String PASSWORD = "key-1bf2a2f243e18be640b2428ddf03ded9";

    private static final String LVSINCO_PASSWORD = "key-246cd85eb5603c3d4924531e5d5c4edc";

    private static final String TENCENT_SMS_SECRET_ID = "AKIDBB3jEqR0Y95zpfTix1vd6fMqAIahc4Ka";

    private static final String TENCENT_SMS_SECRET_KEY = "c6YtNm63rcQ1QdiGmEbmEPSTPF3e4KQK";

    private static final String TENCENT_SMS_SKD_APP_ID = "1400796314";

    private static final String TENCENT_SMS_SIGN_NAME = "杭州崇宇信息";

    private static final String TENCENT_SMS_TEMPLATE_ID = "1705927";

    //国际腾讯云短信
    private static final String TENCENT_SMS_INTERNATIONAL_TEMPLATE_ID = "1705927";

    //账号修改密码国际短信通知
    private static final String TENCENT_SMS_ACCOUNT_INTERNATIONAL_TEMPLATE_ID = "2040574";


    private static final String TENCENT_CAPTCHA_SECRET_ID = "AKIDogNE1uQ3azlVH0582pS0gRD7HZ3aIAYs";

    private static final String TENCENT_CAPTCHA_SECRET_KEY = "Ig2SnIyeHqK5tmrw27kR4bJ727bAsjSX";

    //腾讯云图形认证密钥id
    private static final Long TENCENT_CAPTCHA_APP_ID = 197694921l;

    //腾讯云图形认证密钥key
    private static final String TENCENT_CAPTCHA_APP_SECRET_KEY = "vOd32NejzMM2HQX0WtKy7ItvK";

    private static final Logger log = LoggerFactory.getLogger(SmsUtil.class);

    public static void main(String[] args) {
        send("15720916464", "尊敬的用户，您的验证码为123456，此验证码仅用于银河录像。【崇宇信息】");
    }

    public static void send(String mobile, String msg) {
        HttpRequest request = new HttpRequest(URL);
        request.setMethod(Method.POST);
        request.basicAuth("api", PASSWORD);
        request.form("mobile", mobile);
        request.form("message", msg);
        HttpResponse execute = request.execute();
        System.out.println(execute.body());
    }

    public static Boolean sendLuoKey2Msg(String mobile, String msg) throws Exception {
        HttpRequest request = new HttpRequest(URL);
        request.setMethod(Method.POST);
        request.basicAuth("api", LVSINCO_PASSWORD);
        request.form("mobile", mobile);
        request.form("message", msg);
        HttpResponse execute = request.execute();
        JSONObject re = Jsons.parseObject(execute.body(), JSONObject.class);
        if (re.getInt("error") == 0) {
            log.info(execute.body());
            return true;
        }
        log.error(execute.body());
        return false;
    }

    public static Boolean batchSendLuoKey2Msg(List<String> mobile, String msg) throws Exception {
        HttpRequest request = new HttpRequest(BATCH_URL);
        request.setMethod(Method.POST);
        request.basicAuth("api", LVSINCO_PASSWORD);
        request.form("mobile_list", mobile.stream().collect(Collectors.joining(",")));
        request.form("message", msg);
        HttpResponse execute = request.execute();
        JSONObject re = Jsons.parseObject(execute.body(), JSONObject.class);
        if (re.getInt("error") == 0) {
            log.info(execute.body());
            return true;
        }
        log.error(execute.body());
        return false;
    }

    public static Boolean sendTencent(Integer cid, String mobile, String msg) {
        String templateId = TENCENT_SMS_TEMPLATE_ID;
        if (cid != 86) {
            templateId = TENCENT_SMS_INTERNATIONAL_TEMPLATE_ID;
        }
        return commonSendTencentSmsMsg(templateId, cid, mobile, msg);
    }

    public static Boolean sendAccountInternalSmsMsg(Integer cid, String mobile, String msg) {
        String templateId = TENCENT_SMS_ACCOUNT_INTERNATIONAL_TEMPLATE_ID;
        return commonSendTencentSmsMsg(templateId, cid, mobile, msg);
    }

    public static Boolean commonSendTencentSmsMsg(String templateId, Integer cid, String mobile, String msg) {
        try {
            /* 必要步骤：
             * 实例化一个认证对象，入参需要传入腾讯云账户密钥对secretId，secretKey。
             * 这里采用的是从环境变量读取的方式，需要在环境变量中先设置这两个值。
             * 你也可以直接在代码中写死密钥对，但是小心不要将代码复制、上传或者分享给他人，
             * 以免泄露密钥对危及你的财产安全。
             * SecretId、SecretKey 查询: https://console.cloud.tencent.com/cam/capi */
            Credential cred = new Credential(TENCENT_SMS_SECRET_ID, TENCENT_SMS_SECRET_KEY);
            HttpProfile httpProfile = new HttpProfile();
            httpProfile.setReqMethod("POST");
            /* SDK有默认的超时时间，非必要请不要进行调整
             * 如有需要请在代码中查阅以获取最新的默认值 */
            httpProfile.setConnTimeout(60);
            /* 指定接入地域域名，默认就近地域接入域名为 sms.tencentcloudapi.com ，也支持指定地域域名访问，例如广州地域的域名为 sms.ap-guangzhou.tencentcloudapi.com
             * 南京地域
             * */
            httpProfile.setEndpoint("sms.ap-nanjing.tencentcloudapi.com");

            /* 非必要步骤:
             * 实例化一个客户端配置对象，可以指定超时时间等配置 */
            ClientProfile clientProfile = new ClientProfile();
            /* SDK默认用TC3-HMAC-SHA256进行签名
             * 非必要请不要修改这个字段 */
            clientProfile.setSignMethod("HmacSHA256");
            clientProfile.setHttpProfile(httpProfile);
            /* 实例化要请求产品(以sms为例)的client对象
             * 第二个参数是地域信息，可以直接填写字符串ap-guangzhou，支持的地域列表参考 https://cloud.tencent.com/document/api/382/52071#.E5.9C.B0.E5.9F.9F.E5.88.97.E8.A1.A8
             * 南京地域
             * */
            SmsClient client = new SmsClient(cred, "ap-nanjing", clientProfile);
            /* 实例化一个请求对象，根据调用的接口和实际情况，可以进一步设置请求参数
             * 你可以直接查询SDK源码确定接口有哪些属性可以设置
             * 属性可能是基本类型，也可能引用了另一个数据结构
             * 推荐使用IDE进行开发，可以方便的跳转查阅各个接口和数据结构的文档说明 */
            SendSmsRequest req = new SendSmsRequest();

            /* 短信应用ID: 短信SdkAppId在 [短信控制台] 添加应用后生成的实际SdkAppId，示例如1400006666 */
            // 应用 ID 可前往 [短信控制台](https://console.cloud.tencent.com/smsv2/app-manage) 查看
            req.setSmsSdkAppId(TENCENT_SMS_SKD_APP_ID);

            /* 短信签名内容: 使用 UTF-8 编码，必须填写已审核通过的签名 */
            req.setSignName(TENCENT_SMS_SIGN_NAME);

            /* 模板 ID: 必须填写已审核通过的模板 ID */
            req.setTemplateId(templateId);

            /* 模板参数: 模板参数的个数需要与 TemplateId 对应模板的变量个数保持一致，若无模板参数，则设置为空 */
            String[] templateParamSet = {msg};
            req.setTemplateParamSet(templateParamSet);

            /* 下发手机号码，采用 E.164 标准，+[国家或地区码][手机号]
             * 示例如：+8613711112222， 其中前面有一个+号 ，86为国家码，13711112222为手机号，最多不要超过200个手机号 */
            mobile = String.format("+%s%s", cid, mobile);
            String[] phoneNumberSet = {mobile};
            req.setPhoneNumberSet(phoneNumberSet);

            /* 通过 client 对象调用 SendSms 方法发起请求。注意请求方法名与请求对象是对应的
             * 返回的 res 是一个 SendSmsResponse 类的实例，与请求对象对应 */
            SendSmsResponse res = client.SendSms(req);
            // 输出json格式的字符串回包
            log.info(SendSmsResponse.toJsonString(res));
            SendStatus[] sendStatusSet = res.getSendStatusSet();
            SendStatus sendStatus = sendStatusSet[0];
            if ("Ok".equalsIgnoreCase(sendStatus.getCode())) {
                return true;
            }

            // 也可以取出单个值，你可以通过官网接口文档或跳转到response对象的定义处查看返回字段的定义
            // System.out.println(res.getRequestId());

            /* 当出现以下错误码时，快速解决方案参考
             * [FailedOperation.SignatureIncorrectOrUnapproved](https://cloud.tencent.com/document/product/382/9558#.E7.9F.AD.E4.BF.A1.E5.8F.91.E9.80.81.E6.8F.90.E7.A4.BA.EF.BC.9Afailedoperation.signatureincorrectorunapproved-.E5.A6.82.E4.BD.95.E5.A4.84.E7.90.86.EF.BC.9F)
             * [FailedOperation.TemplateIncorrectOrUnapproved](https://cloud.tencent.com/document/product/382/9558#.E7.9F.AD.E4.BF.A1.E5.8F.91.E9.80.81.E6.8F.90.E7.A4.BA.EF.BC.9Afailedoperation.templateincorrectorunapproved-.E5.A6.82.E4.BD.95.E5.A4.84.E7.90.86.EF.BC.9F)
             * [UnauthorizedOperation.SmsSdkAppIdVerifyFail](https://cloud.tencent.com/document/product/382/9558#.E7.9F.AD.E4.BF.A1.E5.8F.91.E9.80.81.E6.8F.90.E7.A4.BA.EF.BC.9Aunauthorizedoperation.smssdkappidverifyfail-.E5.A6.82.E4.BD.95.E5.A4.84.E7.90.86.EF.BC.9F)
             * [UnsupportedOperation.ContainDomesticAndInternationalPhoneNumber](https://cloud.tencent.com/document/product/382/9558#.E7.9F.AD.E4.BF.A1.E5.8F.91.E9.80.81.E6.8F.90.E7.A4.BA.EF.BC.9Aunsupportedoperation.containdomesticandinternationalphonenumber-.E5.A6.82.E4.BD.95.E5.A4.84.E7.90.86.EF.BC.9F)
             * 更多错误，可咨询[腾讯云助手](https://tccc.qcloud.com/web/im/index.html#/chat?webAppId=8fa15978f85cb41f7e2ea36920cb3ae1&title=Sms)
             */

        } catch (TencentCloudSDKException e) {
            log.error("发送腾讯云短信错误,e:{}", e);
        }
        return false;
    }

    public static void checkTencentCaptcha(String ticket, String userIp,String randsStr) {
        try {
            // 实例化一个认证对象，入参需要传入腾讯云账户 SecretId 和 SecretKey，此处还需注意密钥对的保密
            // 代码泄露可能会导致 SecretId 和 SecretKey 泄露，并威胁账号下所有资源的安全性。以下代码示例仅供参考，建议采用更安全的方式来使用密钥，请参见：https://cloud.tencent.com/document/product/1278/85305
            // 密钥可前往官网控制台 https://console.cloud.tencent.com/cam/capi 进行获取
            Credential cred = new Credential(TENCENT_CAPTCHA_SECRET_ID, TENCENT_CAPTCHA_SECRET_KEY);
            // 实例化一个http选项，可选的，没有特殊需求可以跳过
            HttpProfile httpProfile = new HttpProfile();
            // 推荐使用北极星，相关指引可访问如下链接
            // https://git.woa.com/tencentcloud-internal/tencentcloud-sdk-java#%E5%8C%97%E6%9E%81%E6%98%9F
            httpProfile.setEndpoint("captcha.tencentcloudapi.com");
            // 实例化一个client选项，可选的，没有特殊需求可以跳过
            ClientProfile clientProfile = new ClientProfile();
            clientProfile.setHttpProfile(httpProfile);
            // 实例化要请求产品的client对象,clientProfile是可选的
            CaptchaClient client = new CaptchaClient(cred, "", clientProfile);
            // 实例化一个请求对象,每个接口都会对应一个request对象
            DescribeCaptchaResultRequest req = new DescribeCaptchaResultRequest();
            req.setCaptchaType(9L);
            req.setTicket(ticket);
            req.setUserIp(userIp);
            req.setRandstr(randsStr);
            req.setCaptchaAppId(TENCENT_CAPTCHA_APP_ID);
            req.setAppSecretKey(TENCENT_CAPTCHA_APP_SECRET_KEY);

            // 返回的resp是一个DescribeCaptchaResultResponse的实例，与请求对象对应
            DescribeCaptchaResultResponse resp = client.DescribeCaptchaResult(req);
            //1 OK 验证通过
            Long captchaCode = resp.getCaptchaCode();
            if (captchaCode != 1) {
                log.error("腾讯云图形验证错误：{}", resp.getCaptchaMsg());
                throw BusinessRuntimeException.getInstance("图形验证失败");
            }
        } catch (TencentCloudSDKException e) {
            log.error("腾讯云图形认证异常：{}", StringUtil.getErrorText(e));
        }
    }
}
